﻿Module Prozessdaten
    '###########################################################
    '# Behandlung der Prozessdaten aus der Stuktur
    '# und Speichern in prz File
    '###########################################################
    Public Pfad_Prozess As String


#Region " Prozessdaten"
    '###########################################################
    '# Rekursiver Bildung der Prozessdaten
    '###########################################################
    Public Function Build_Processdaten(ByVal Istwerte_Struct As Object) As IEnumerable(Of String)
        Dim fields As Reflection.FieldInfo() = Istwerte_Struct.GetType.GetFields(Reflection.BindingFlags.Public Or Reflection.BindingFlags.Instance)
        Dim result As New List(Of String)()
        For i As Integer = 0 To fields.Length - 1
            Dim val As Object = fields(i).GetValue(Istwerte_Struct)
            If val Is Nothing Then
                result.Add("")
                Continue For
            End If
            Dim TypeofValue = val.[GetType]()
            If TypeofValue.IsValueType AndAlso Not TypeofValue.IsPrimitive AndAlso Not TypeofValue.IsEnum Then
                result.AddRange(Build_Processdaten(val))  ' Rekursion um unterliegende Strukturen aufzulösen
            Else
                Dim Type As String = val.GetType.ToString
                If (Type = "System.Double") Then
                    result.Add(Math.Round(val, 3).ToString)
                Else
                    result.Add(val.ToString())
                End If
            End If

        Next
        Return result
    End Function

    '###########################################################
    '# Rekursiver Bildung der Prozessdatennamen
    '###########################################################
    Public Function Build_Processdaten_Namen(ByVal Istwerte_Struct As Object, ByVal Knoten As String) As IEnumerable(Of String)
        Dim fields As Reflection.FieldInfo() = Istwerte_Struct.GetType.GetFields(Reflection.BindingFlags.Public Or Reflection.BindingFlags.Instance)
        Dim result As New List(Of String)()
        For i As Integer = 0 To fields.Length - 1
            Dim val As Object = fields(i).GetValue(Istwerte_Struct)
            Dim val_Name As Object = fields(i).Name
            If val Is Nothing Then
                result.Add(Knoten + val_Name)
                Continue For
            End If
            Dim TypeofValue = val.[GetType]()
            If TypeofValue.IsValueType AndAlso Not TypeofValue.IsPrimitive AndAlso Not TypeofValue.IsEnum Then
                result.AddRange(Build_Processdaten_Namen(val, val_Name + "."))  ' Rekursion um unterliegende Strukturen aufzulösen
            Else
                result.Add(Knoten + val_Name.ToString())
            End If

        Next
        Return result
    End Function

    Public Function Build_Processdaten_Namen_und_Type(ByVal Istwerte_Struct As Object, ByVal Knoten As String) As IEnumerable(Of String)
        Dim fields As Reflection.FieldInfo() = Istwerte_Struct.GetType.GetFields(Reflection.BindingFlags.Public Or Reflection.BindingFlags.Instance)
        Dim result As New List(Of String)()
        For i As Integer = 0 To fields.Length - 1
            Dim val As Object = fields(i).GetValue(Istwerte_Struct)
            Dim val_Name As Object = fields(i).Name
            Dim val_Type As Type = fields(i).FieldType
            If val Is Nothing Then
                result.Add(Knoten + val_Name + " " + val_Type.Name)
                Continue For
            End If
            Dim TypeofValue = val.[GetType]()
            If TypeofValue.IsValueType AndAlso Not TypeofValue.IsPrimitive AndAlso Not TypeofValue.IsEnum Then
                result.AddRange(Build_Processdaten_Namen(val, val_Name + " " + val_Type.Name))  ' Rekursion um unterliegende Strukturen aufzulösen
            Else
                result.Add(Knoten + val_Name.ToString() + " " + val_Type.Name)
            End If

        Next
        Return result
    End Function

    Public Function Build_Processdaten(ByVal Istwerte_Struct As Object, ByVal Knoten As String) As IEnumerable(Of String)
        Dim fields As Reflection.FieldInfo() = Istwerte_Struct.GetType.GetFields(Reflection.BindingFlags.Public Or Reflection.BindingFlags.Instance)
        Dim result As New List(Of String)()
        For i As Integer = 0 To fields.Length - 1
            Dim val As Object = fields(i).GetValue(Istwerte_Struct)
            Dim val_Name As Object = fields(i).Name
            If val Is Nothing Then
                result.Add(Knoten + val_Name)
                Continue For
            End If
            Dim TypeofValue = val.[GetType]()
            If TypeofValue.IsValueType AndAlso Not TypeofValue.IsPrimitive AndAlso Not TypeofValue.IsEnum Then
                result.AddRange(Build_Processdaten_Namen(val, val_Name + "."))  ' Rekursion um unterliegende Strukturen aufzulösen
            Else
                result.Add(Knoten + val_Name.ToString())
            End If

        Next
        Return result
    End Function

    '###########################################################
    '# Rekursiver Bildung der Daten und Schreiben in prz File
    '###########################################################
    Public Sub Write_Istwerte(ByVal Type As String)
        Dim fw As IO.StreamWriter
        Dim Name As String
        Dim Namen As String
        Dim Values As String
        Dim Ueberschriften As IEnumerable(Of String)
        Dim Werte As IEnumerable(Of String)

        'Vorbelegung des Speicherortes
        Name = Pfad_Prozess
        Name = Name + Now.ToString("yyyy_MM_dd") + "_" + Type
        ' Bilden der Überschriften



        ' Bilden der Prozessdaten
        Values = Now.ToString + ";"             ' Erste Line Beschreibung
        Werte = Build_Processdaten(Istdaten)    ' Bilden der Werte aus Istwertstruktur
        For Each Value In Werte
            Values = Values + Value.ToString + ";"
        Next

        Try
            If Not IO.File.Exists(Name + ".prz") Then            ' Wenn Datei noch nicht da dann neu erstellen mit Überschrift  
                fw = New IO.StreamWriter(Name + ".prz", True) ' Datei Öffnen
                ' Daten Anhängen
                fw.WriteLine("Prozessdaten :")
                fw.WriteLine("Prozessdaten Hella LED Test und Montageeinheit G0x  ")
                Namen = "Datum" + ";"
                Ueberschriften = Build_Processdaten_Namen(Istdaten, "")   ' Knoten dient zun Auflösen der Unterstrukturen
                For Each Name In Ueberschriften
                    Namen = Namen + Name.ToString + ";"
                Next
                fw.WriteLine(Namen)  'Ueberschriften
                fw.WriteLine(Values) ' Daten Schreiben
            Else
                fw = New IO.StreamWriter(Name + ".prz", True) ' Datei Öffnen
                fw.WriteLine(Values)
            End If


        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error beim Schreiben in die Prozessdatei", MessageBoxButtons.OK, MessageBoxIcon.Error)
            '  BDE_TRACE_Line(BDE_DATEI, "ERROR   :;" + "Error beim Schreiben in die Prozessdatei")
        Finally
            'Close the file.
            fw.Close()
        End Try


    End Sub
    Public Sub Write_Istwerte(ByVal Type As String, ByVal Istdaten_Nest As Pruefung_Istdaten)
        Dim fw As IO.StreamWriter
        Dim Name As String
        Dim Namen As String
        Dim Values As String
        Dim Ueberschriften As IEnumerable(Of String)
        Dim Werte As IEnumerable(Of String)

        'Vorbelegung des Speicherortes
        Name = Pfad_Prozess
        Name = Name + Now.ToString("yyyy_MM_dd") + "_" + Type
        ' Bilden der Überschriften



        ' Bilden der Prozessdaten
        Values = Now.ToString + ";"             ' Erste Line Beschreibung
        Werte = Build_Processdaten(Istdaten_Nest)    ' Bilden der Werte aus Istwertstruktur
        For Each Value In Werte
            Values = Values + Value.ToString + ";"
        Next

        Try
            If Not IO.File.Exists(Name + ".prz") Then            ' Wenn Datei noch nicht da dann neu erstellen mit Überschrift  
                fw = New IO.StreamWriter(Name + ".prz", True) ' Datei Öffnen
                ' Daten Anhängen
                fw.WriteLine("Prozessdaten :")
                fw.WriteLine("Prozessdaten Hella RGB Flasher Audi RGB Lichtband ")
                Namen = "Datum" + ";"
                Ueberschriften = Build_Processdaten_Namen(Istdaten_Nest, "")   ' Knoten dient zun Auflösen der Unterstrukturen
                For Each Name In Ueberschriften
                    Namen = Namen + Name.ToString + ";"
                Next
                fw.WriteLine(Namen)  'Ueberschriften
                fw.WriteLine(Values) ' Daten Schreiben
            Else
                fw = New IO.StreamWriter(Name + ".prz", True) ' Datei Öffnen
                fw.WriteLine(Values)
            End If


        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error beim Schreiben in die Prozessdatei", MessageBoxButtons.OK, MessageBoxIcon.Error)
            '  BDE_TRACE_Line(BDE_DATEI, "ERROR   :;" + "Error beim Schreiben in die Prozessdatei Nest ")
        Finally
            'Close the file.
            fw.Close()
        End Try


    End Sub

    'Public Function Anzeige_Istwerte() As String
    '    Dim Values As String
    '    Dim List_2 As String()
    '    Dim Benennung As IEnumerable(Of String)
    '    Dim Werte As IEnumerable(Of String)
    '    Dim i As Integer
    '    Try
    '        Values = ""
    '        Werte = Build_Processdaten(Istdaten)    ' Bilden der Werte aus Istwertstruktur
    '        For Each value In Werte
    '            Values = Values + value.ToString + ";"
    '        Next
    '        '  List_2 = Split(Values, ";")
    '        Anzeige_Istwerte = ""
    '        Benennung = Build_Processdaten_Namen(Istdaten, "")   ' Knoten dient zun Auflösen der Unterstrukturen
    '        For Each Namen In Benennung
    'Anzeige_Istwerte = Anzeige_Istwerte + Namen.ToString + "  = " + Werte(i) + vbCrLf
    'i = i + 1
    '        Next

    '    Catch ex As Exception
    '        Anzeige_Istwerte = " Anzeige_Istwerte nicht möglich keine Istwerte vorhanden"
    '    End Try

    'End Function
    '**************************************************

#End Region

End Module
