﻿
Imports System.Data.SqlClient

Module SQL_Vorbereitungen
    'Create ADO.NET objects.
    Private myConnection_String = "Data Source=S04380317\SQLEXPRESS;"
    Private mySecurity = "Integrated security=SSPI"
    Private myConn As SqlConnection
    Private myCmd As SqlCommand
    Private myReader As SqlDataReader
    Private results As String
    Public nameOfColumns() As String

#Region " Datenbank Anlegen "


    Public Sub Connect_TD_SQL_DB(ByVal Connection As String)

    End Sub

    ''' <summary>
    ''' Anlegen Einer Leeren datenbank 
    ''' Custommer = Datenbankname "AUDI/BMW/DAIMLER"
    ''' </summary>
    ''' <param name="Customer"></param>
    Public Sub Create_TD_Database(Customer As String)
        ' https://www.dofactory.com/reference/connection-strings   Datenbank Verbindungsstrings

        ' Erzeugen DB
        Dim str As String = String.Empty

        myConn = New SqlConnection(myConnection_String & mySecurity)
        Dim oPfad As String = "G:\"

        str = "CREATE DATABASE " + Customer + " ON PRIMARY " &
              "(NAME = " + Customer + ", " &
              "FILENAME = '" & oPfad & Customer & ".mdf', " &
              "SIZE = 3MB, MAXSIZE = 10MB, FILEGROWTH = 10%) " &
              "LOG ON (NAME = " & Customer & "Log2, " &
              "FILENAME = '" & oPfad & Customer & ".ldf', " &
              "SIZE = 1MB, " &
              "MAXSIZE = 5MB, " &
              "FILEGROWTH = 10%)"

        Dim myCommand As SqlCommand = New SqlCommand(str, myConn)
        Try
            myConn.Open()
            myCommand.ExecuteNonQuery()
            '    MessageBox.Show("DataBase is Created Successfully", "MyProgram",
            '   MessageBoxButtons.OK, MessageBoxIcon.Information)
        Catch ex As Exception
            'MsgBox(ex.Message, MsgBoxStyle.Information)
        Finally
            If myConn.State = ConnectionState.Open Then
                myConn.Close()
            End If
        End Try

    End Sub

    ''' <summary>
    ''' Crate Table aus aktuellen Prozessdaten
    ''' </summary>
    ''' <param name="Part_Nr"></param>
    ''' <param name="Customer"></param>
    ''' <param name="Inhalte"></param>
    Public Sub Create_TD_Table(Part_Nr As String, Customer As String, Inhalte As Object)
        ' test SQL Syntax  https://www.eversql.com/sql-syntax-check-validator/
        ' Achtung DB Namen müssen mit einem Buchstaben Beginnen Zahlen sind erst danach zulässig
        myConn = New SqlConnection(myConnection_String & "Database=" & Customer & ";" & mySecurity)

        Dim oCommand As SqlCommand = myConn.CreateCommand()

        Dim Inhalts_STR As String
        Inhalts_STR = Istdaten_Anpassen_An_SQL(Build_Processdaten_Namen_und_Type(Inhalte, ""))
        Dim Prim As String = "  CONSTRAINT PK_Date_SN PRIMARY KEY (Datum,Seriennummer)"    ' Definition Prmary Key mit Datun und Seriennummer   Wird momentan nicht benutzt
        oCommand.CommandText = "CREATE TABLE " & Part_Nr & "( " & Inhalts_STR & ");"
        'oCommand.CommandText = "CREATE TABLE " & Part_Nr & "( PersonID Int,LastName varchar(255),Address varchar(255),City varchar(255));"
        myCmd = oCommand

        Try
            myConn.Open()
            myCmd.ExecuteNonQuery()
        Catch ex As Exception
            Console.WriteLine(ex.Message)
            '    MsgBox(ex.Message, MsgBoxStyle.Information)
        Finally
            If myConn.State = ConnectionState.Open Then
                myConn.Close()
            End If
        End Try

    End Sub
    ''' <summary>
    ''' Kontrolle ob Kundendatenbank vorhanden
    ''' </summary>
    ''' <param name="Customer">Datenbanknamen </param>
    ''' <returns>TRUE = Vorhanden</returns>
    Public Function Check_TD_DB(Customer As String) As Boolean
        ' Kontrolle DB Vorahnden
        myConn = New SqlConnection(myConnection_String & mySecurity)

        Dim oCommand As SqlCommand = myConn.CreateCommand()
        oCommand.CommandText = "SELECT database_id FROM sys.databases WHERE [name] LIKE '" & Customer & "'"
        myCmd = oCommand
        Try
            myConn.Open()
            Check_TD_DB = myCmd.ExecuteReader.HasRows
        Catch ex As Exception
            Check_TD_DB = False
        Finally
            If myConn.State = ConnectionState.Open Then
                myConn.Close()
            End If
        End Try

    End Function
    ''' <summary>
    ''' Kontrolle ob Tebelle vorhanden
    ''' </summary>
    ''' <param name="Customer">Datenbank Namen</param>
    ''' <param name="Part_Nr">Teilenummer</param>
    ''' <returns>TRUE = vorhanden</returns>
    Public Function Check_TD_Table(Customer As String, Part_Nr As String) As Boolean
        ' Kontrolle Table Vorahnden
        ' Kontrolle DB Vorahnden
        myConn = New SqlConnection(myConnection_String & "Database=" & Customer & ";" & mySecurity)

        Dim oCommand As SqlCommand = myConn.CreateCommand()
        oCommand.CommandText = "SELECT 1 FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_NAME = '" & Part_Nr & "'"
        myCmd = oCommand
        Try
            myConn.Open()
            Check_TD_Table = myCmd.ExecuteReader.HasRows
        Catch ex As Exception
            Check_TD_Table = False
        Finally
            If myConn.State = ConnectionState.Open Then
                myConn.Close()
            End If
        End Try


    End Function

#End Region



#Region "Hilfsfunktionen"
    ''' <summary>
    ''' Daten an SQL Vormate anpassen
    ''' </summary>
    ''' <param name="Values"></param>
    ''' <returns></returns>
    Public Function Anpassen_Values(ByVal Values As String) As String
        Anpassen_Values = Values.Replace("True", "1").Replace("False", "0")
        Anpassen_Values = Anpassen_Values.Replace("TRUE", "1").Replace("FALSE", "0")
    End Function
    ''' <summary>
    ''' Aus Aktuellem Datung TXT machen
    ''' </summary>
    ''' <returns></returns>
    Public Function Get_Date_As_Integer() As Integer
        Dim Datum As String = Format(Now, "yyyy:MM:dd")
        Datum = Datum.Replace(":", "")
        Get_Date_As_Integer = CInt(Datum)
    End Function
    ''' <summary>
    ''' Bilden SQL daten aus Istwerte Struktur
    ''' </summary>
    ''' <param name="Istwerte_Struct"></param>
    ''' <returns></returns>
    Public Function Build_Processdaten_for_SQL(ByVal Istwerte_Struct As Object) As IEnumerable(Of String)
        Dim fields As Reflection.FieldInfo() = Istwerte_Struct.GetType.GetFields(Reflection.BindingFlags.Public Or Reflection.BindingFlags.Instance)
        Dim result As New List(Of String)()
        For i As Integer = 0 To fields.Length - 1
            Dim val As Object = fields(i).GetValue(Istwerte_Struct)
            If val Is Nothing Then
                result.Add("")
                Continue For
            End If
            Dim TypeofValue = val.[GetType]()
            If TypeofValue.IsValueType AndAlso Not TypeofValue.IsPrimitive AndAlso Not TypeofValue.IsEnum Then
                result.AddRange(Build_Processdaten(val))  ' Rekursion um unterliegende Strukturen aufzulösen
            Else
                Dim Type As String = val.GetType.ToString
                If (Type = "System.Double") Then
                    result.Add(Math.Round(val, 3).ToString)
                ElseIf (Type = "System.String") Then
                    result.Add("'" & (val).ToString & "'")

                Else
                    result.Add(val.ToString())
                End If
            End If

        Next
        Return result
    End Function
    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="connectionString"></param>
    ''' <param name="nameOfTable"></param>
    ''' <param name="nameOfColumn"></param>
    ''' <param name="selNameOfColumn"></param>
    ''' <param name="selValueOfColumn"></param>
    ''' <returns></returns>
    Public Function SelectCells(ByVal connectionString As String, ByVal nameOfTable As String, ByVal nameOfColumn() As String, ByVal selNameOfColumn As String, ByVal selValueOfColumn As String) As String()

        ' der Rückgabewert dieser Funktion ist der gesuchte Zelleninhalt:
        ' ---------------------------------------------------------------
        '  wenn der Wert selValueOfColumn in der Spalte selNameOfColumn existiert => return readData=Zelleninhalt,
        '  wenn der Wert selValueOfColumn in der Spalte selNameOfColumn nicht existiert => return readData=""


        ' der selectSQL-String ist ein SQL-statement, welches Datensaetze aus einer Tabelle AUSWÄHLT:
        ' Syntax:  SELECT <Spaltenname1>, <Spaltenname2>, ... FROM <Tabellenname> WHERE <Suchbedingung>
        ' z.B.     SELECT nameOfColumn(0), nameOfColumn(1), ... FROM nameOfTable WHERE selNameOfColumn="selValueOfColumn"


        Dim readData() As String = {}

        ' Bilden des selectSQL-Strings
        Dim selectSQL As String = "SELECT "
        For Each name As String In nameOfColumn
            selectSQL = selectSQL & name & ","
        Next name
        If (nameOfColumn.Length > 0) Then
            selectSQL = selectSQL.Remove(selectSQL.LastIndexOf(","), 1)
        End If
        selectSQL = selectSQL & " FROM " & nameOfTable & " WHERE " & selNameOfColumn & " = '" & selValueOfColumn & "'"


        Using connection As New SqlClient.SqlConnection(connectionString)

            Dim command As New SqlClient.SqlCommand(selectSQL)

            ' setzen der Connection auf die neue OleDbConnection
            command.Connection = connection

            ' Verbindung Öffnen und Ausführen des select-Kommandos
            Try
                connection.Open()
                Dim reader As SqlClient.SqlDataReader = command.ExecuteReader

                ' Datensatz Auslesen
                While reader.Read()
                    Dim dataArray(reader.VisibleFieldCount - 1) As String
                    For data As Integer = 0 To reader.VisibleFieldCount - 1
                        dataArray.SetValue(reader.GetValue(data).ToString, data)
                    Next data
                    readData = dataArray
                End While

                ' die Verbindung (connection) wird automatisch geschlossen, wenn der Code in einem Using block steht

            Catch ex As Exception
                MsgBox(" Fehler beim Zugriff auf Datenbank (Select Cells): " & ex.Message)
            End Try

        End Using

        Return readData

    End Function
    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="connectionString"></param>
    ''' <param name="nameOfTable"></param>
    ''' <param name="nameOfColumn"></param>
    ''' <param name="selNameOfColumn"></param>
    ''' <param name="selValueOfColumn"></param>
    ''' <returns></returns>
    Public Function SelectCell(ByVal connectionString As String, ByVal nameOfTable As String, ByVal nameOfColumn As String, ByVal selNameOfColumn As String, ByVal selValueOfColumn As String) As String

        ' der Rückgabewert dieser Funktion ist der gesuchte Zelleninhalt:
        ' ---------------------------------------------------------------
        '  wenn der Wert selValueOfColumn in der Spalte selNameOfColumn existiert => return readData=Zelleninhalt,
        '  wenn der Wert selValueOfColumn in der Spalte selNameOfColumn nicht existiert => return readData=""


        ' der selectSQL-String ist ein SQL-statement, welches Datensaetze aus einer Tabelle AUSWÄHLT:
        ' Syntax:  SELECT <Spaltenname> FROM <Tabellenname> WHERE <Suchbedingung>
        ' z.B.     SELECT nameOfColumn FROM nameOfTable WHERE selNameOfColumn="selValueOfColumn"


        Dim readData As String = ""

        ' Bilden des selectSQL-Strings
        Dim selectSQL As String = "SELECT " & nameOfColumn & " FROM " & nameOfTable & " WHERE " & selNameOfColumn & " = '" & selValueOfColumn & "'"


        Using connection As New SqlClient.SqlConnection(connectionString)

            Dim command As New SqlClient.SqlCommand(selectSQL)

            ' setzen der Connection auf die neue OleDbConnection
            command.Connection = connection

            ' Verbindung Öffnen und Ausführen des select-Kommandos
            Try
                connection.Open()
                Dim reader As SqlClient.SqlDataReader = command.ExecuteReader

                ' Datensatz Auslesen
                While reader.Read()
                    If (reader.VisibleFieldCount > 0) Then
                        readData = reader.GetValue(0).ToString
                    End If
                End While

                ' die Verbindung (connection) wird automatisch geschlossen, wenn der Code in einem Using block steht

            Catch ex As Exception
                MsgBox(" Fehler beim Zugriff auf Datenbank (Select Cell): " & ex.Message)
            End Try

        End Using

        Return readData

    End Function
    ''' <summary>
    ''' Datentypen an SQL anpassen 
    ''' </summary>
    ''' <param name="Values"></param>
    ''' <returns></returns>
    Public Function Istdaten_Anpassen_An_SQL(ByVal Values As IEnumerable(Of String)) As String
        Istdaten_Anpassen_An_SQL = ""
        Dim I As Integer = 0
        For Each Value In Values
            Istdaten_Anpassen_An_SQL = Istdaten_Anpassen_An_SQL & Value.ToString + " ,"  ' Komma als Trennzeichen zwichen den werten
        Next
        Istdaten_Anpassen_An_SQL = Mid(Istdaten_Anpassen_An_SQL, 1, Len(Istdaten_Anpassen_An_SQL) - 1)      ' Letztes Komma Wegschneiden

        Istdaten_Anpassen_An_SQL = Replace(Istdaten_Anpassen_An_SQL, " Boolean", " BIT", 1, 20)       ' Anpassen an SQL Syntax
        Istdaten_Anpassen_An_SQL = Replace(Istdaten_Anpassen_An_SQL, " Int64", " BIGINT", 1, 20)       ' Anpassen an SQL Syntax
        Istdaten_Anpassen_An_SQL = Replace(Istdaten_Anpassen_An_SQL, " Int32", " Integer", 1, 20)       ' Anpassen an SQL Syntax
        Istdaten_Anpassen_An_SQL = Replace(Istdaten_Anpassen_An_SQL, " String", " varchar(30)", 1, 100)  ' Anpassen an SQL Syntax
        Istdaten_Anpassen_An_SQL = Replace(Istdaten_Anpassen_An_SQL, " Double", " float", 1, 100)  ' Anpassen an SQL Syntax


    End Function

#End Region



End Module
